## 题目描述

One night, having had a hard day at work, Petya saw a nightmare. There was a binary search tree in the dream. But it was not the actual tree that scared Petya. The horrifying thing was that Petya couldn’t search for elements in this tree. Petya tried many times to choose key and look for it in the tree, and each time he arrived at a wrong place. Petya has been racking his brains for long, choosing keys many times, but the result was no better. But the moment before Petya would start to despair, he had an epiphany: every time he was looking for keys, the tree didn’t have the key, and occured exactly one mistake. “That’s not a problem!”, thought Petya. “Why not count the expectation value of an element, which is found when I search for the key”. The moment he was about to do just that, however, Petya suddenly woke up.

Thus, you are given a binary search tree, that is a tree containing some number written in the node. This number is called the node key. The number of children of every node of the tree is equal either to $0$ or to $2$. The nodes that have $0$ children are called leaves and the nodes that have $2$ children, are called inner. An inner node has the left child, that is the child whose key is less than the current node’s key, and the right child, whose key is more than the current node’s key. Also, a key of any node is strictly larger than all the keys of the left subtree of the node and strictly smaller than all the keys of the right subtree of the node.

Also you are given a set of search keys, all of which are distinct and differ from the node keys contained in the tree. For each key from the set its search in the tree is realised. The search is arranged like this: initially we are located in the tree root, if the key of the current node is larger that our search key, then we move to the left child of the node, otherwise we go to the right child of the node and the process is repeated. As it is guaranteed that the search key is not contained in the tree, the search will always finish in some leaf. The key lying in the leaf is declared the search result.

It is known for sure that during the search we make a mistake in comparing exactly once, that is we go the wrong way, but we won’t make any mistakes later. All possible mistakes are equiprobable, that is we should consider all such searches where exactly one mistake occurs. Your task is to find the expectation (the average value) of the search result for every search key, considering that exactly one mistake occurs in the search. That is, for a set of paths containing exactly one mistake in the given key search, you should count the average value of keys containing in the leaves of those paths.

## 题意概述

给定一棵包含$n$个节点的二叉搜索树，每个节点都有$0$个或$2$个儿子。如果一个节点有儿子，那么它左子树中的所有节点的值都严格小于这个节点，它右子树中的所有节点的值都严格大于这个节点。由于一些差错，这棵搜索树在查找一个值时总是会犯恰好一次错误——应该往左查找时却往右查找，应该往右查找时却往左查找。现有$k$个树中不存在的值待查找，求每一次查找得到的数的期望。

数据范围：$3 \le n \lt 10^5, \; 1 \le k \le 10^5$。

## 算法分析

很容易想到暴力的方法：先DFS预处理出每棵子树中的最大值和最小值，接着对于每一个待查找的值，直接在树中查找；若应该往左子树走，则将答案加上右子树中的最小值，否则加上左子树中的最大值，然后往正确的方向走。由于这并不是一棵平衡树，因此最坏情况的时间复杂度为$O(n^2)$。

搜索树中的数将数字划分成了$(n+1)$个区间。对于每一个区间而言，其答案都是一样的。因此，我们可以再进行一次DFS，处理出每个区间的答案。处理方法类似于暴力，但是搜索完一棵子树后需要回溯。最后查找$k$个数时，只需对每个数二分查找属于哪个区间，并输出那个区间的答案。

## 代码

#include <cstdio> #include <algorithm> using namespace std; struct node_type { long long val, min, max, child[2]; } node[100001]; long long n, k, cnt, times, root, top, id[100001]; double ans[100001]; void dfs(long long t) { if (!node[t].child[0]) { node[t].min = node[t].max = node[t].val; return; } dfs(node[t].child[0]), dfs(node[t].child[1]); node[t].min = node[node[t].child[0]].min, node[t].max = node[node[t].child[1]].max; } void find(long long t) { if (!node[t].child[0]) { id[top] = node[t].val, ans[top++] = 1.0 * cnt / times; return; } cnt += node[node[t].child[1]].min, ++times, find(node[t].child[0]), id[top++] = node[t].val; cnt += node[node[t].child[0]].max - node[node[t].child[1]].min, find(node[t].child[1]); cnt -= node[node[t].child[0]].max, --times; } int main() { scanf("%lld", &n); for (int i = 1; i <= n; ++i) { long long a; scanf("%lld%lld", &a, &node[i].val); if (a == -1) root = i; else if (!node[a].child[0]) node[a].child[0] = i; else { node[a].child[1] = i; if (node[node[a].child[0]].val > node[node[a].child[1]].val) node[a].child[0] ^= node[a].child[1] ^= node[a].child[0] ^= node[a].child[1]; } } dfs(root), find(root), scanf("%lld", &k); for (int i = top - 2; i >= 0; --i) if (!ans[i]) ans[i] = ans[i + 1]; while (k--) { long long a, l = 0, r = top; scanf("%lld", &a); while (l + 1 < r) { long long mid = l + r >> 1; if (id[mid] < a) l = mid; else r = mid; } printf("%.10lf\n", ans[l]); } return 0; }